using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    public partial class T_Sys_SeatPermissionConfig
    {
        public T_Sys_SeatPermissionConfig()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_Id", "T_Sys_SeatPermissionConfig");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_SeatPermissionConfig");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists()
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_SeatPermissionConfig");
            return DbHelperSQL.Exists(strSql.ToString(), null);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(Model.T_Sys_SeatPermissionConfig model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_SeatPermissionConfig(");
            strSql.Append("F_MaxSeat,F_PassHash,F_SaltValue,F_SecurityKey)");
            strSql.Append(" values (");
            strSql.Append("@F_MaxSeat,@F_PassHash,@F_SaltValue,@F_SecurityKey)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_MaxSeat", SqlDbType.Int,4),
                    new SqlParameter("@F_PassHash", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_SaltValue", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_SecurityKey", SqlDbType.NVarChar,500)};
            parameters[0].Value = model.F_MaxSeat;
            parameters[1].Value = model.F_PassHash;
            parameters[2].Value = model.F_SaltValue;
            parameters[3].Value = model.F_SecurityKey;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_Sys_SeatPermissionConfig model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_SeatPermissionConfig set ");
            strSql.Append("F_MaxSeat=@F_MaxSeat,");
            strSql.Append("F_PassHash=@F_PassHash,");
            strSql.Append("F_SaltValue=@F_SaltValue,");
            strSql.Append("F_SecurityKey=@F_SecurityKey");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_MaxSeat", SqlDbType.Int,4),
                    new SqlParameter("@F_PassHash", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_SaltValue", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_SecurityKey", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.F_MaxSeat;
            parameters[1].Value = model.F_PassHash;
            parameters[2].Value = model.F_SaltValue;
            parameters[3].Value = model.F_SecurityKey;
            parameters[4].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_SeatPermissionConfig ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_SeatPermissionConfig ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Sys_SeatPermissionConfig GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_MaxSeat,F_PassHash,F_SaltValue,F_SecurityKey from T_Sys_SeatPermissionConfig ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            Model.T_Sys_SeatPermissionConfig model = new Model.T_Sys_SeatPermissionConfig();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Sys_SeatPermissionConfig GetModel()
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_MaxSeat,F_SecurityKey,F_PassHash,F_SaltValue from T_Sys_SeatPermissionConfig ");
            Model.T_Sys_SeatPermissionConfig model = new Model.T_Sys_SeatPermissionConfig();
            DataSet ds = DbHelperSQL.Query(strSql.ToString());
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Sys_SeatPermissionConfig DataRowToModel(DataRow row)
        {
            Model.T_Sys_SeatPermissionConfig model = new Model.T_Sys_SeatPermissionConfig();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["F_MaxSeat"] != null && row["F_MaxSeat"].ToString() != "")
                {
                    model.F_MaxSeat = int.Parse(row["F_MaxSeat"].ToString());
                }
                if (row["F_PassHash"] != null)
                {
                    model.F_PassHash = row["F_PassHash"].ToString();
                }
                if (row["F_SaltValue"] != null)
                {
                    model.F_SaltValue = row["F_SaltValue"].ToString();
                }
                if (row["F_SecurityKey"] != null)
                {
                    model.F_SecurityKey = row["F_SecurityKey"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_MaxSeat,F_PassHash,F_SaltValue,F_SecurityKey ");
            strSql.Append(" FROM T_Sys_SeatPermissionConfig ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_MaxSeat,F_PassHash,F_SaltValue,F_SecurityKey ");
            strSql.Append(" FROM T_Sys_SeatPermissionConfig ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_SeatPermissionConfig ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_SeatPermissionConfig T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Sys_SeatPermissionConfig";
			parameters[1].Value = "F_Id";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
